{-# OPTIONS_GHC -fglasgow-exts #-}

module CetaVerifier where {

import List;
import Product_Type;
import ProofChecker;
import Eithera;
import Nat;
import Xml;
import Show;
import Option;

search_len :: [Char] -> [Char] -> Nat -> Maybe ([Char], [Char]);
search_len t s n =
  (if takea n t == s then Just ([], dropa n t)
    else (case t of {
           [] -> Nothing;
           h : tt ->
             (case search_len tt s n of {
               Nothing -> Nothing;
               Just a -> let {
                           (bef, aft) = a;
                         } in Just (h : bef, aft);
             });
         }));

eqWhiteSpace :: [Char] -> [Char] -> Bool;
eqWhiteSpace s1 s2 =
  filtera (\ c -> not (member c wspace)) s1 ==
    filtera (\ c -> not (member c wspace)) s2;

extract_goal_input :: [Char] -> Maybe [Char];
extract_goal_input s =
  (case search_len s ['<', 'g', 'o', 'a', 'l', '>']
          (size_list ['<', 'g', 'o', 'a', 'l', '>'])
    of {
    Nothing -> Nothing;
    Just a ->
      let {
        (x, mgoal) = a;
      } in (case search_len mgoal ['<', '/', 'g', 'o', 'a', 'l', '>']
                   (size_list ['<', '/', 'g', 'o', 'a', 'l', '>'])
             of {
             Nothing -> Nothing;
             Just aa ->
               let {
                 (goal, s') = aa;
               } in (case search_len s' ['<', 'i', 'n', 'p', 'u', 't', '>']
                            (size_list ['<', 'i', 'n', 'p', 'u', 't', '>'])
                      of {
                      Nothing -> Nothing;
                      Just ab ->
                        let {
                          (xa, minput) = ab;
                        } in (case search_len minput
                                     ['<', '/', 'i', 'n', 'p', 'u', 't', '>']
                                     (size_list
                                       ['<', '/', 'i', 'n', 'p', 'u', 't', '>'])
                               of {
                               Nothing -> Nothing;
                               Just ac ->
                                 let {
                                   (input, xb) = ac;
                                 } in Just
(concata
  [['<', 'p', 'r', 'o', 'b', 'l', 'e', 'm', '>'],
    ['<', 'g', 'o', 'a', 'l', '>'], goal, ['<', '/', 'g', 'o', 'a', 'l', '>'],
    ['<', 'i', 'n', 'p', 'u', 't', '>'], input,
    ['<', '/', 'i', 'n', 'p', 'u', 't', '>'],
    ['<', '/', 'p', 'r', 'o', 'b', 'l', 'e', 'm', '>']]);
                             });
                    });
           });
  });

certifyProof :: [Char] -> CertificationResult;
certifyProof problemString =
  (case parseCertProblem problemString of {
    Lefta err ->
      Error (append
              (append
                ['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'i', 'l', 'e', ' ',
                  'p', 'a', 'r', 's', 'i', 'n', 'g']
                newline)
              err);
    Righta cp ->
      (case extract_goal_input problemString of {
        Nothing ->
          Error ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'f', 'i',
                  'n', 'd', ' ', 'g', 'o', 'a', 'l', ' ', 'a', 'n', 'd', ' ',
                  'i', 'n', 'p', 'u', 't', ' ', 'i', 'n', ' ', 's', 't', 'r',
                  'i', 'n', 'g', ' ', 'f', 'o', 'r', ' ', 'c', 'o', 'm', 'p',
                  'a', 'r', 'i', 's', 'o', 'n', ' ', 'w', 'i', 't', 'h', ' ',
                  'p', 'a', 'r', 's', 'e', 'd', ' ', 'r', 'e', 's', 'u', 'l',
                  't'];
        Just inpProblem ->
          (if eqWhiteSpace inpProblem (sshow_xml (xml_certificationProblem cp))
            then certifyCertProblem cp
            else Error (concata
                         [['p', 'a', 'r', 's', 'e', 'd', ' ', 'p', 'r', 'o',
                            'b', 'l', 'e', 'm', ' ', 'd', 'o', 'e', 's', ' ',
                            'n', 'o', 't', ' ', 'c', 'o', 'r', 'r', 'e', 's',
                            'p', 'o', 'n', 'd', ' ', 't', 'o', ' ', 'i', 'n',
                            'p', 'u', 't'],
                           newline, ['i', 'n', 'p', 'u', 't', ':'], newline,
                           filtera (\ c -> not (member c wspace)) inpProblem,
                           newline, newline,
                           ['p', 'a', 'r', 's', 'e', 'd', ':'], newline,
                           filtera (\ c -> not (member c wspace))
                             (sshow_xml (xml_certificationProblem cp)),
                           newline]));
      });
  });

}
