{-# OPTIONS_GHC -fglasgow-exts #-}

module Show where {

import qualified List;
import qualified Nat;
import qualified Integer;
import qualified Util;

sEmpty :: [Char];
sEmpty = [];

class Sshow a where {
  sshow :: a -> [Char];
};

tabC :: Char;
tabC = '\^I';

tab :: [Char];
tab = [Show.tabC];

newlineC :: Char;
newlineC = '\^J';

newline :: [Char];
newline = [Show.newlineC];

sshowa :: forall c d. (Show.Sshow c, Show.Sshow d) => (c, d) -> [Char];
sshowa (x, y) = List.concata [Show.sshow x, [' ', '-', '>', ' '], Show.sshow y];

showLista :: [[Char]] -> [Char];
showLista xs = Util.flat_map (\ x -> List.append x Show.newline) xs;

digit2string :: Nat.Nat -> [Char];
digit2string n =
  (if n == Nat.Zero_nat then ['0']
    else (if n == Nat.one_nat then ['1']
           else (if n == Integer.nat 2 then ['2']
                  else (if n == Integer.nat 3 then ['3']
                         else (if n == Integer.nat 4 then ['4']
                                else (if n == Integer.nat 5 then ['5']
                                       else (if n == Integer.nat 6 then ['6']
      else (if n == Integer.nat 7 then ['7']
             else (if n == Integer.nat 8 then ['8']
                    else (if n == Integer.nat 9 then ['9']
                           else ['n', 'o', 't', ' ', 'a', ' ', 'd', 'i', 'g',
                                  'i', 't']))))))))));

sshow_nat :: Nat.Nat -> [Char];
sshow_nat n =
  (if Nat.less_nat n (Integer.nat 10) then Show.digit2string n
    else List.append (Show.sshow_nat (Nat.div_nat n (Integer.nat 10)))
           (Show.digit2string (Nat.mod_nat n (Integer.nat 10))));

sshow_int :: Integer -> [Char];
sshow_int i =
  (if i < 0 then List.append ['-'] (Show.sshow_nat (Integer.nat (0 - i)))
    else Show.sshow_nat (Integer.nat i));

instance Show.Sshow Integer where {
  sshow = Show.sshow_int;
};

instance Show.Sshow Nat.Nat where {
  sshow = Show.sshow_nat;
};

sshow_char :: Char -> [Char];
sshow_char x = [x];

instance Show.Sshow Char where {
  sshow = Show.sshow_char;
};

sshow_list :: forall a. (Show.Sshow a) => [a] -> [Char];
sshow_list xs = Util.flat_map Show.sshow xs;

instance (Show.Sshow a) => Show.Sshow [a] where {
  sshow = Show.sshow_list;
};

fresh_strings_list :: [Char] -> Nat.Nat -> [[Char]] -> Nat.Nat -> [[Char]];
fresh_strings_list name offset used n =
  List.takea n
    (List.filtera (\ s -> not (List.member s (List.remdups used)))
      (List.mapa
        (\ i -> List.append name (Show.sshow_nat (Nat.plus_nat i offset)))
        (List.upt Nat.Zero_nat (Nat.plus_nat n (List.length_unique used)))));

}
